/***************************************************************************
 *   trn - semestralni prace do x36osy                                     *
 *   Copyright (C) 2006 by Michal Turek                                    *
 *   WOQ (at) seznam.cz, http://woq.nipax.cz/                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <sys/time.h>
#include "all.h"

#ifndef __CTRANSLATER_H__
#define __CTRANSLATER_H__


class CTranslater
{
public:
	CTranslater();
	~CTranslater();

	bool TryToOccupy();// true = byl volny a muze se zacit pouzivat

	void Push(char c);
	char Pop();

	int GetID() const { return m_id; }
	void JobFinished();
	void CondSignal();// Kvuli ukonceni aplikace

private:
	int m_id;
	bool m_occupied;
	pthread_mutex_t m_mutex;
	pthread_cond_t m_cond;
	queue<char> m_queue;

	static int m_num_translaters;// Citac pro vypisy
};


#endif
